<template>
  <v-list-item
    :input-value="value"
    :disabled="disabled && !readOnly"
    @click="toggleTraining"
  >
    <template v-slot:default="{ active, toggle }">
      <v-list-item-action v-if="!readOnly">
        <v-badge overlap>
          <template v-slot:badge>
            <span v-if="value">{{ position }}</span>
          </template>
          <v-checkbox v-model="active" :disabled="disabled" @click="toggle" />
        </v-badge>
      </v-list-item-action>

      <v-list-item-content>
        <v-list-item-title>
          {{ startHours }}h{{ startMinutes }}
        </v-list-item-title>
        <v-list-item-subtitle>
          {{ lengthHours }}h{{ lengthMinutes }}

          <template
            v-if="training.indicativeMinAge && training.indicativeMaxAge"
          >
            − {{ training.indicativeMinAge }}-{{ training.indicativeMaxAge }}
            ans
          </template>
          <template v-else>
            <template v-if="training.indicativeMinAge">
              − {{ training.indicativeMinAge }}+ ans
            </template>
            <template v-if="training.indicativeMaxAge">
              − {{ training.indicativeMaxAge }}- ans
            </template>
          </template>

          <template v-if="training.comment">
            − {{ training.comment }}
          </template>
        </v-list-item-subtitle>
      </v-list-item-content>
    </template>
  </v-list-item>
</template>

<script>
export default {
  props: {
    training: {
      type: Object,
      required: true,
    },
    value: {
      type: Boolean,
      default: false,
    },
    position: {
      type: Number,
      default: 0,
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    readOnly: {
      type: Boolean,
      default: false,
    },
  },

  computed: {
    isFull() {
      return this.training.available <= 0
    },

    displayVariant() {
      return this.value ? 'primary' : 'secondary'
    },

    startMinutes() {
      return ((this.training.startTime * 60) % 60).toLocaleString('fr', {
        minimumIntegerDigits: 2,
      })
    },
    startHours() {
      return Math.floor(this.training.startTime).toLocaleString('fr', {
        minimumIntegerDigits: 2,
      })
    },
    lengthMinutes() {
      return this.training.duration % 60 === 0
        ? ''
        : (this.training.duration % 60).toLocaleString('fr', {
            minimumIntegerDigits: 2,
          })
    },
    lengthHours() {
      return Math.floor(this.training.duration / 60)
    },
  },

  methods: {
    toggleTraining() {
      this.$emit('input', !this.value)
    },
  },
}
</script>
